<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{basePath}/jquery-3.5.1.min.js"></script>
    <script src="{basePath}/common.js"></script>
    <link rel="stylesheet" href="{basePath}/simulatorViewDark.css">
    <link rel="stylesheet" href="{basePath}/bootstrap-4.5.2-dist/css/bootstrap.css">
</head>

<body>
    <nav class="navbar navbar-inverse navbar-fixed-top justify-content-start">
        <input class="form-control" style="width: 150px; float: left; margin-right: 5px;" id="start_address" />
        <button id="startButton" type="button" class="btn btn-primary" onclick='start()'>Start</button>
        <button type="button" id="btn_step" class="btn btn-primary" onclick='step()'>step</button>
        <button type="button" class="btn btn-primary" onclick='registers()'>registers</button>
        <button type="button" class="btn btn-primary" onclick='version()'>version</button>
        <button type="button" class="btn btn-primary" onclick='cont()'>cont</button>
        <button type="button" class="btn btn-primary" onclick='pause()'>pause</button>
    </nav>
    <div class="container-fluid" style="position: relative; z-index: 0; margin-top: 50px;">
        <div class="row">
            <div class="col">
                <pre id="stdin" tabindex="0"></pre>
            </div>
        </div>
    </div>
    <script>
        const vscode = acquireVsCodeApi();
        window.addEventListener('message', event => {
            const message = event.data;
            switch (message.type) {
                case 'stdout':
                    if (message.data == 'BS') {
                        $('#stdin').html($('#stdin').html().substring(0, $('#stdin').html().length - 1));
                    } else {
                        $('#stdin').append(escapeHTML(message.data));
                        window.scrollTo(0, document.body.scrollHeight);
                    }
                    break;
                case 'version':
                    vscode.window.showInformationMessage('version: ' + message.xml);
                    break;
            }
        });

        function start() {
            if ($('#startButton').text() == "Start") {
                $('#startButton').text("Stop");
                var start_address = document.querySelector("#start_address").value;

                vscode.postMessage({
                    command: 'start',
                    address: start_address
                });
            } else if ($('#startButton').text() == "Stop") {
                $('#startButton').text("Start");
                vscode.postMessage({
                    command: 'kill'
                });
            }
        }

        function step() {
            document.getElementById("btn_step").disabled=true;
            setTimeout('document.getElementById("btn_step").disabled=false;',1500);
            vscode.postMessage({
                command: 'step',
            });
        }

        function registers() {
            vscode.postMessage({
                command: 'registers',
            });
        }

        function version() {
            vscode.postMessage({
                command: 'version',
            });
        }

        function cont() {
            console.log('peter1');
            vscode.postMessage({
                command: 'cont',
            });
        }
        function pause() {
            vscode.postMessage({
                command: 'pause',
            });
        }
        $("#stdin").keyup(function(evt) {
            if (evt.keyCode == 8) {
                vscode.postMessage({
                    command: 'keypress',
                    keyCode: evt.keyCode
                });
            }
        });

        $("#stdin").keypress(function(evt) {
            vscode.postMessage({
                command: 'keypress',
                keyCode: evt.keyCode
            });
        });
    </script>
</body>

</html>